/* 
   $Id: calendar.h,v 1.6 2001/12/27 08:21:15 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgsched.

   sgsched is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgsched is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgsched; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

struct dayrule{
  char *name;
  int  month;
  int  mday;
  int  nth;
  int  wday;
  int  equinox;
  struct dayrule *next;
};

struct date{
  int year;
  int mon;
  int mday;
};

int    diff_time_t(time_t t1, time_t t2);

int    get_spring_equinox(int year);
int    get_autumn_equinox(int year);
int    get_leapyear(int year);
int    get_day_of_month(int year, int month);
int    get_dayweek(int year, int month, int day);

int    comp_date(struct date *a, struct date *b);
time_t get_time_t(int year, int mon, int day, int hour, int min, int sec);

int           load_holiday(char *fn);
int           load_memorial(char *fn);
int           is_holiday(int year, int month, int day);

struct date * get_next_sunday(int year, int month, int day);
struct date * get_next_public_holiday(int year, int month, int day);
struct date * get_next_holiday(int year, int month, int day);
struct date * get_nholidays(int year, int month, int day, int n, int max);
struct date * get_holiday_by_name(char *name, int year);
char        * get_holiday_by_date(int year, int month, int day);

struct date * get_memorialday_by_name(char *name, int year);
char        * get_memorialday_by_date(int year, int month, int day);
struct date * get_next_memorialday(int year, int month, int day);

#define next_day(y, m, d) \
{ \
  d++; \
  if(d > get_day_of_month(y, m)){ \
    m++; \
    if(m > 12) y++, m = 1; \
    d = 1; \
  } \
} \

#define prev_day(y, m, d) \
{ \
  d--; \
  if(d < 1){ \
    m--; \
    if(m < 1) y--, m = 1; \
    d = get_day_of_month(y, m); \
  } \
} \
