/* 
   $Id: schedule.h,v 1.6 2001/12/27 08:21:15 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgsched.

   sgsched is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgsched is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgsched; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <time.h>

#define NORMAL_SCHEDULE  (1 << 0)
#define WEEKLY_SCHEDULE  (1 << 1)
#define MONTHLY_SCHEDULE (1 << 2)
#define DAYOFF_SCHEDULE  (1 << 3)

#define MEMORIAL_SCHEDULE (1 << 6)
#define HOLIDAY_SCHEDULE  (1 << 7)

struct sched_data {
  struct sched_data *prev, *next;
  struct sched_data *orig;
  time_t      time;
  time_t      start;
  time_t      end;
  long        flag;
  char        *location;
  char        *person;
  char        *data;
};


void                sched_add_data(struct sched_data *data);
void                sched_del_data(struct sched_data *data);

struct sched_data * sched_load_list(char *fn);
void                sched_save_list(char *fn);
int                 append_schedule_data(char *fn, struct sched_data *sched);

struct sched_data * sched_create_list(int sy, int sm, int sd, int ey, int em, int ed);
void                sched_destroy_list(struct sched_data *list);
struct sched_data * sort_schedule_list(struct sched_data *list);

struct sched_data * make_next_weekly_schedule(struct sched_data *sc, int y, int m, int d);

struct sched_data * get_schedule_time(int year, int mon, int day, int hour, int min);
struct sched_data * get_schedule_after_time(int year, int mon, int day, int hour, int min);
struct sched_data * get_schedule_after_day(int sy, int sm, int sd, int days);
struct sched_data * search_free_time(int year, int mon, int mday, int wday, int hour, int min, int interval, int max);

int get_number_of_schedule(int sy, int sm, int sd);

int is_pm(time_t t);

