/* 
   $Id: sgsched.h,v 1.6 2001/12/27 08:21:15 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgsched.

   sgsched is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgsched is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgsched; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <X11/X.h>

#include <gnome.h>

#define CAL_WIDTH 4

#define DAY_VIEW   0
#define WEEK_VIEW  1
#define MONTH_VIEW 2

#include "schedule.h"
#include "calendar.h"
#include "sg_aplaunch.h"

/* sgsched_main.c */
void init_view(GtkWidget *app);
void set_page(int i);
void move_today(GtkWidget *widget, gpointer data);
void quit_ev(GtkWidget *widget, gpointer data);
void quit_with_save(void);
void quit(void);
void close_dialog(GtkWidget *widget, gpointer data);
void message_btn(char *message, void (*y_func)(), void (*n_func)());

void cut_command(void);
void copy_command(void);
void paste_command(void);

void cut_text(void);
void copy_text(void);
void paste_text(void);
void selall_text(void);
void cut_sched(void);
void copy_sched(void);
void paste_sched(void);

void set_selection_src_widget(GtkWidget *widget, GdkEventFocus *ev);
void unset_selection_src_widget(GtkWidget *widget, GdkEventFocus *ev);

/* sgsched_edit.c */
void init_edit(GtkWidget *notebook);
int  get_ok_btn_state(void);
void set_ok_btn_state(int i);
int  get_entry_num(GtkWidget *widget);
void set_entry_num(GtkWidget *widget, int num);
void ok_press(GtkWidget *widget, gpointer data);
void cancel_press(GtkWidget *widget, gpointer data);
void check_selected_day(GtkWidget *widget, gpointer data);
void load_location_data(void);
void load_person_data(void);
void create_combo(GtkWidget *edit_table);
void create_select_dialog(GtkWidget *w, void (*ok_func)(), void (*cancel_func)());
void check_specified_day(GtkWidget *widget, gpointer data);
void create_specify_combo(void);
void destroy_specify_date(GtkWidget *widget, gpointer data);
void specify_date(void);
void move_specified_day(GtkWidget *widget, gpointer data);

/* sgsched_btn.c */
void new_press(GtkWidget *widget, gpointer data);
void del_press(GtkWidget *widget, gpointer data);
void edit_press(GtkWidget *widget, gpointer data);
void view_press(GtkWidget *widget, gpointer data);

void set_sched_data_now(void);

int  get_view_state(void);
void set_ok_btn_state(int i);
void set_sched_data(struct sched_data *data);
void set_schedule_list(void);

/* sgsched_cal.c */
GtkWidget * init_calendar(void);
void        init_holiday(void);
void        draw_calendar(int year, int month, int day);

/* sgsched_list.c */
extern GtkWidget  * sched_list;
GtkWidget         * init_list(void);
struct sched_data * get_selected_row_data(void);

void sched_set_list(int year, int month, int day);

struct sched_data * get_sched_list(int y, int m);
struct sched_data * get_sched_previous_list(int y, int m);
void                set_calendar_state(int year, int month);
