/* 
   $Id: sgsched_btn.c,v 1.6 2001/12/27 08:21:16 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgsched.

   sgsched is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgsched is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgsched; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "config.h"

#include <stdio.h>
#include "sgsched.h"

static int view_state = DAY_VIEW;

extern GtkWidget *year_label;
extern GtkWidget *month_label;

extern int    current_year;
extern int    current_month;
extern int    current_day;

extern struct sched_data *sc_current;
extern struct sched_data *sc_previous;

extern GtkWidget *notebook;

extern char *month_name[12];

int get_view_state()
{
  return view_state;
}

void view_press(GtkWidget *widget, gpointer data)
{
  char *title0;
  char *title1;
  view_state = (gint) data;

  switch (view_state) {
  case WEEK_VIEW:
    title0 = _("Date");
    title1 = _("week plan");
    break;
  case MONTH_VIEW:
    title0 = _("Date");
    title1 = _("month plan");
    break;
  case DAY_VIEW:
  default:
    title0 = _("Time");
    title1 = _("day plan");
    break;
  }

  gtk_clist_set_column_title(GTK_CLIST(sched_list),0,title0);
  gtk_clist_set_column_title(GTK_CLIST(sched_list),1,title1);
  
  sched_set_list(current_year, current_month, current_day);
  set_calendar_state(current_year, current_month);
  draw_calendar(current_year, current_month, current_day);
}

void set_sched_data_now()
{
  struct sched_data tmp;
  struct tm tm;

  tm.tm_year = current_year - 1900;
  tm.tm_mon  = current_month - 1;
  tm.tm_mday = current_day;
  tm.tm_hour = 0;
  tm.tm_min  = 0;
  tm.tm_sec  = 0;
  tm.tm_isdst = -1;

  tmp.start = mktime(&tm);
  tmp.end   = mktime(&tm);
  tmp.flag  = NORMAL_SCHEDULE;
  tmp.location = NULL;
  tmp.person  = NULL;
  tmp.data  = NULL;

  set_sched_data(&tmp);
}

void edit_press(GtkWidget *widget, gpointer data)
{
  struct sched_data *tmp;
  int num;

  num = (int)gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
  
  if(num == 0 || get_ok_btn_state() != 0){
    tmp = get_selected_row_data();
    if(tmp && (tmp->flag & ~(HOLIDAY_SCHEDULE|MEMORIAL_SCHEDULE))){
      set_sched_data(tmp);
      set_ok_btn_state(1);
    }else{
      set_sched_data_now();
      set_ok_btn_state(0);
    }
  }
  set_page(1);
}

void new_press(GtkWidget *widget, gpointer data)
{
  set_sched_data_now();
  set_ok_btn_state(0);
  set_page(1);
}

void del_press(GtkWidget *widget, gpointer data)
{
  struct sched_data *tmp;
  int num;

  num = (int)gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));

  if(num == 0 || get_ok_btn_state() != 0){
    tmp = get_selected_row_data();
    if(tmp && (tmp->flag & ~(HOLIDAY_SCHEDULE|MEMORIAL_SCHEDULE))){
      set_sched_data(tmp);
      set_ok_btn_state(2);
      set_page(1);
    }
  }
}
